// Code generated by entc, DO NOT EDIT.

package ent

import (
	"context"
	"fmt"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"github.com/valocode/bubbly/ent/predicate"
	"github.com/valocode/bubbly/ent/releasepolicyviolation"
)

// ReleasePolicyViolationDelete is the builder for deleting a ReleasePolicyViolation entity.
type ReleasePolicyViolationDelete struct {
	config
	hooks    []Hook
	mutation *ReleasePolicyViolationMutation
}

// Where appends a list predicates to the ReleasePolicyViolationDelete builder.
func (rpvd *ReleasePolicyViolationDelete) Where(ps ...predicate.ReleasePolicyViolation) *ReleasePolicyViolationDelete {
	rpvd.mutation.Where(ps...)
	return rpvd
}

// Exec executes the deletion query and returns how many vertices were deleted.
func (rpvd *ReleasePolicyViolationDelete) Exec(ctx context.Context) (int, error) {
	var (
		err      error
		affected int
	)
	if len(rpvd.hooks) == 0 {
		affected, err = rpvd.sqlExec(ctx)
	} else {
		var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
			mutation, ok := m.(*ReleasePolicyViolationMutation)
			if !ok {
				return nil, fmt.Errorf("unexpected mutation type %T", m)
			}
			rpvd.mutation = mutation
			affected, err = rpvd.sqlExec(ctx)
			mutation.done = true
			return affected, err
		})
		for i := len(rpvd.hooks) - 1; i >= 0; i-- {
			if rpvd.hooks[i] == nil {
				return 0, fmt.Errorf("ent: uninitialized hook (forgotten import ent/runtime?)")
			}
			mut = rpvd.hooks[i](mut)
		}
		if _, err := mut.Mutate(ctx, rpvd.mutation); err != nil {
			return 0, err
		}
	}
	return affected, err
}

// ExecX is like Exec, but panics if an error occurs.
func (rpvd *ReleasePolicyViolationDelete) ExecX(ctx context.Context) int {
	n, err := rpvd.Exec(ctx)
	if err != nil {
		panic(err)
	}
	return n
}

func (rpvd *ReleasePolicyViolationDelete) sqlExec(ctx context.Context) (int, error) {
	_spec := &sqlgraph.DeleteSpec{
		Node: &sqlgraph.NodeSpec{
			Table: releasepolicyviolation.Table,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeInt,
				Column: releasepolicyviolation.FieldID,
			},
		},
	}
	if ps := rpvd.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	return sqlgraph.DeleteNodes(ctx, rpvd.driver, _spec)
}

// ReleasePolicyViolationDeleteOne is the builder for deleting a single ReleasePolicyViolation entity.
type ReleasePolicyViolationDeleteOne struct {
	rpvd *ReleasePolicyViolationDelete
}

// Exec executes the deletion query.
func (rpvdo *ReleasePolicyViolationDeleteOne) Exec(ctx context.Context) error {
	n, err := rpvdo.rpvd.Exec(ctx)
	switch {
	case err != nil:
		return err
	case n == 0:
		return &NotFoundError{releasepolicyviolation.Label}
	default:
		return nil
	}
}

// ExecX is like Exec, but panics if an error occurs.
func (rpvdo *ReleasePolicyViolationDeleteOne) ExecX(ctx context.Context) {
	rpvdo.rpvd.ExecX(ctx)
}
