// Code generated by entc, DO NOT EDIT.

package ent

import (
	"context"
	"errors"
	"fmt"

	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"github.com/valocode/bubbly/ent/testcase"

	schema "github.com/valocode/bubbly/ent/schema/types"
	"github.com/valocode/bubbly/ent/testrun"
)

// TestCaseCreate is the builder for creating a TestCase entity.
type TestCaseCreate struct {
	config
	mutation *TestCaseMutation
	hooks    []Hook
}

// SetName sets the "name" field.
func (tcc *TestCaseCreate) SetName(s string) *TestCaseCreate {
	tcc.mutation.SetName(s)
	return tcc
}

// SetResult sets the "result" field.
func (tcc *TestCaseCreate) SetResult(b bool) *TestCaseCreate {
	tcc.mutation.SetResult(b)
	return tcc
}

// SetMessage sets the "message" field.
func (tcc *TestCaseCreate) SetMessage(s string) *TestCaseCreate {
	tcc.mutation.SetMessage(s)
	return tcc
}

// SetElapsed sets the "elapsed" field.
func (tcc *TestCaseCreate) SetElapsed(f float64) *TestCaseCreate {
	tcc.mutation.SetElapsed(f)
	return tcc
}

// SetNillableElapsed sets the "elapsed" field if the given value is not nil.
func (tcc *TestCaseCreate) SetNillableElapsed(f *float64) *TestCaseCreate {
	if f != nil {
		tcc.SetElapsed(*f)
	}
	return tcc
}

// SetMetadata sets the "metadata" field.
func (tcc *TestCaseCreate) SetMetadata(s schema.Metadata) *TestCaseCreate {
	tcc.mutation.SetMetadata(s)
	return tcc
}

// SetRunID sets the "run" edge to the TestRun entity by ID.
func (tcc *TestCaseCreate) SetRunID(id int) *TestCaseCreate {
	tcc.mutation.SetRunID(id)
	return tcc
}

// SetRun sets the "run" edge to the TestRun entity.
func (tcc *TestCaseCreate) SetRun(t *TestRun) *TestCaseCreate {
	return tcc.SetRunID(t.ID)
}

// Mutation returns the TestCaseMutation object of the builder.
func (tcc *TestCaseCreate) Mutation() *TestCaseMutation {
	return tcc.mutation
}

// Save creates the TestCase in the database.
func (tcc *TestCaseCreate) Save(ctx context.Context) (*TestCase, error) {
	var (
		err  error
		node *TestCase
	)
	tcc.defaults()
	if len(tcc.hooks) == 0 {
		if err = tcc.check(); err != nil {
			return nil, err
		}
		node, err = tcc.sqlSave(ctx)
	} else {
		var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
			mutation, ok := m.(*TestCaseMutation)
			if !ok {
				return nil, fmt.Errorf("unexpected mutation type %T", m)
			}
			if err = tcc.check(); err != nil {
				return nil, err
			}
			tcc.mutation = mutation
			if node, err = tcc.sqlSave(ctx); err != nil {
				return nil, err
			}
			mutation.id = &node.ID
			mutation.done = true
			return node, err
		})
		for i := len(tcc.hooks) - 1; i >= 0; i-- {
			if tcc.hooks[i] == nil {
				return nil, fmt.Errorf("ent: uninitialized hook (forgotten import ent/runtime?)")
			}
			mut = tcc.hooks[i](mut)
		}
		if _, err := mut.Mutate(ctx, tcc.mutation); err != nil {
			return nil, err
		}
	}
	return node, err
}

// SaveX calls Save and panics if Save returns an error.
func (tcc *TestCaseCreate) SaveX(ctx context.Context) *TestCase {
	v, err := tcc.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Exec executes the query.
func (tcc *TestCaseCreate) Exec(ctx context.Context) error {
	_, err := tcc.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (tcc *TestCaseCreate) ExecX(ctx context.Context) {
	if err := tcc.Exec(ctx); err != nil {
		panic(err)
	}
}

// defaults sets the default values of the builder before save.
func (tcc *TestCaseCreate) defaults() {
	if _, ok := tcc.mutation.Elapsed(); !ok {
		v := testcase.DefaultElapsed
		tcc.mutation.SetElapsed(v)
	}
}

// check runs all checks and user-defined validators on the builder.
func (tcc *TestCaseCreate) check() error {
	if _, ok := tcc.mutation.Name(); !ok {
		return &ValidationError{Name: "name", err: errors.New(`ent: missing required field "name"`)}
	}
	if v, ok := tcc.mutation.Name(); ok {
		if err := testcase.NameValidator(v); err != nil {
			return &ValidationError{Name: "name", err: fmt.Errorf(`ent: validator failed for field "name": %w`, err)}
		}
	}
	if _, ok := tcc.mutation.Result(); !ok {
		return &ValidationError{Name: "result", err: errors.New(`ent: missing required field "result"`)}
	}
	if _, ok := tcc.mutation.Message(); !ok {
		return &ValidationError{Name: "message", err: errors.New(`ent: missing required field "message"`)}
	}
	if v, ok := tcc.mutation.Message(); ok {
		if err := testcase.MessageValidator(v); err != nil {
			return &ValidationError{Name: "message", err: fmt.Errorf(`ent: validator failed for field "message": %w`, err)}
		}
	}
	if _, ok := tcc.mutation.Elapsed(); !ok {
		return &ValidationError{Name: "elapsed", err: errors.New(`ent: missing required field "elapsed"`)}
	}
	if v, ok := tcc.mutation.Elapsed(); ok {
		if err := testcase.ElapsedValidator(v); err != nil {
			return &ValidationError{Name: "elapsed", err: fmt.Errorf(`ent: validator failed for field "elapsed": %w`, err)}
		}
	}
	if _, ok := tcc.mutation.RunID(); !ok {
		return &ValidationError{Name: "run", err: errors.New("ent: missing required edge \"run\"")}
	}
	return nil
}

func (tcc *TestCaseCreate) sqlSave(ctx context.Context) (*TestCase, error) {
	_node, _spec := tcc.createSpec()
	if err := sqlgraph.CreateNode(ctx, tcc.driver, _spec); err != nil {
		if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{err.Error(), err}
		}
		return nil, err
	}
	id := _spec.ID.Value.(int64)
	_node.ID = int(id)
	return _node, nil
}

func (tcc *TestCaseCreate) createSpec() (*TestCase, *sqlgraph.CreateSpec) {
	var (
		_node = &TestCase{config: tcc.config}
		_spec = &sqlgraph.CreateSpec{
			Table: testcase.Table,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeInt,
				Column: testcase.FieldID,
			},
		}
	)
	if value, ok := tcc.mutation.Name(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Value:  value,
			Column: testcase.FieldName,
		})
		_node.Name = value
	}
	if value, ok := tcc.mutation.Result(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeBool,
			Value:  value,
			Column: testcase.FieldResult,
		})
		_node.Result = value
	}
	if value, ok := tcc.mutation.Message(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Value:  value,
			Column: testcase.FieldMessage,
		})
		_node.Message = value
	}
	if value, ok := tcc.mutation.Elapsed(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeFloat64,
			Value:  value,
			Column: testcase.FieldElapsed,
		})
		_node.Elapsed = value
	}
	if value, ok := tcc.mutation.Metadata(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeJSON,
			Value:  value,
			Column: testcase.FieldMetadata,
		})
		_node.Metadata = value
	}
	if nodes := tcc.mutation.RunIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: false,
			Table:   testcase.RunTable,
			Columns: []string{testcase.RunColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: &sqlgraph.FieldSpec{
					Type:   field.TypeInt,
					Column: testrun.FieldID,
				},
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_node.test_case_run = &nodes[0]
		_spec.Edges = append(_spec.Edges, edge)
	}
	return _node, _spec
}

// TestCaseCreateBulk is the builder for creating many TestCase entities in bulk.
type TestCaseCreateBulk struct {
	config
	builders []*TestCaseCreate
}

// Save creates the TestCase entities in the database.
func (tccb *TestCaseCreateBulk) Save(ctx context.Context) ([]*TestCase, error) {
	specs := make([]*sqlgraph.CreateSpec, len(tccb.builders))
	nodes := make([]*TestCase, len(tccb.builders))
	mutators := make([]Mutator, len(tccb.builders))
	for i := range tccb.builders {
		func(i int, root context.Context) {
			builder := tccb.builders[i]
			builder.defaults()
			var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
				mutation, ok := m.(*TestCaseMutation)
				if !ok {
					return nil, fmt.Errorf("unexpected mutation type %T", m)
				}
				if err := builder.check(); err != nil {
					return nil, err
				}
				builder.mutation = mutation
				nodes[i], specs[i] = builder.createSpec()
				var err error
				if i < len(mutators)-1 {
					_, err = mutators[i+1].Mutate(root, tccb.builders[i+1].mutation)
				} else {
					spec := &sqlgraph.BatchCreateSpec{Nodes: specs}
					// Invoke the actual operation on the latest mutation in the chain.
					if err = sqlgraph.BatchCreate(ctx, tccb.driver, spec); err != nil {
						if sqlgraph.IsConstraintError(err) {
							err = &ConstraintError{err.Error(), err}
						}
					}
				}
				if err != nil {
					return nil, err
				}
				mutation.id = &nodes[i].ID
				mutation.done = true
				if specs[i].ID.Value != nil {
					id := specs[i].ID.Value.(int64)
					nodes[i].ID = int(id)
				}
				return nodes[i], nil
			})
			for i := len(builder.hooks) - 1; i >= 0; i-- {
				mut = builder.hooks[i](mut)
			}
			mutators[i] = mut
		}(i, ctx)
	}
	if len(mutators) > 0 {
		if _, err := mutators[0].Mutate(ctx, tccb.builders[0].mutation); err != nil {
			return nil, err
		}
	}
	return nodes, nil
}

// SaveX is like Save, but panics if an error occurs.
func (tccb *TestCaseCreateBulk) SaveX(ctx context.Context) []*TestCase {
	v, err := tccb.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Exec executes the query.
func (tccb *TestCaseCreateBulk) Exec(ctx context.Context) error {
	_, err := tccb.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (tccb *TestCaseCreateBulk) ExecX(ctx context.Context) {
	if err := tccb.Exec(ctx); err != nil {
		panic(err)
	}
}
